﻿Option Explicit On
Option Compare Binary
Option Strict On
Imports System
Imports System.Windows.Forms

Public Class frmMessage

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

        With Me
            AddHandler .Load, AddressOf Me_Load
            AddHandler .FormClosing, AddressOf Me_FormClosing
        End With

    End Sub

    Private Sub Me_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs)
        Opacity = 0
    End Sub

    Private Sub Me_Load(ByVal sender As Object, ByVal e As EventArgs)
        'не требуется обрабатывать событие Paint или переопределять событие OnPaint
        'достаточно при помощи статического метода Handle определить указатель
        'на окно, затем по этому указателю, используя статический метод FromHwnd
        'класса Graphics, получить экземпляр класса. Далее требуется при помощи
        'графических методов построить требуемое изображение
        Dim hwnd As New IntPtr
        hwnd = MyBase.Handle
        Dim g As Graphics = Graphics.FromHwnd(hwnd)
        Dim f As Font 'шрифт и его стиль
        Dim c As Integer 'количество символов, которые поместятся в заданный прямоугольник
        Dim l As Integer 'количество сторк, которые поместятся в заданный прямоугольник
        Dim h As Single 'высота строк текста по вертикали
        Dim hr As Single 'высота заданного прямоугольника
        With lbl
            'определяем шрифт и его стиль
            With .Font
                f = New Font(.FontFamily, .Size, .Style)
            End With
            'ограничиваем размер заданного прямоугольника
            hr = f.GetHeight * 25
            'переменные c и l передаются по ссылке и утанавливаются методом MeasureString
            Try
                g.MeasureString(.Text, f, New SizeF(.Width, hr), New StringFormat, c, l)
            Catch ex As Exception
                l = 25
            End Try
            'определяем высоту строк текста по вертикали
            h = l * f.GetHeight(g)
            'изменяем размер окна сообщения, если это необходимо
            If l > 2 Then
                Height += CInt(h - .Height) + 10
                If l = 25 Then
                    With rtxt
                        .Location = .Location
                        .Size = .Size
                        .Text = .Text
                        .Visible = True
                    End With
                    .Visible = False
                End If
            End If
        End With
    End Sub

End Class